#!/usr/bin/env bash

if [ -z "$BASH_SOURCE" ]; then
    # If not running bash, try to obtain directory with $0
    BASEDIR="$( cd "$(dirname "$0")"; pwd -P )"
else
    BASEDIR=$(dirname ${BASH_SOURCE[0]})
fi
command -v realpath &> /dev/null && BASEDIR=$(realpath ${BASEDIR}/../..) || BASEDIR=$(cd ${BASEDIR}/../.. && pwd)

if [ ! -d "${BASEDIR}" ]; then
    echo "${BASEDIR} does not exist"
    return 1
fi

omnitrace_ROOT=${BASEDIR}
PATH=${BASEDIR}/bin:${PATH}
LD_LIBRARY_PATH=${BASEDIR}/lib:${LD_LIBRARY_PATH}
PYTHONPATH=${BASEDIR}/lib/python/site-packages:${PYTHONPATH}
CMAKE_PREFIX_PATH=${BASEDIR}:${CMAKE_PREFIX_PATH}
omnitrace_DIR=${BASEDIR}/share/cmake/omnitrace

export omnitrace_ROOT
export PATH
export LD_LIBRARY_PATH
export PYTHONPATH
export CMAKE_PREFIX_PATH
export omnitrace_DIR

# ROCm environment variables
# HSA_TOOLS_LIB="${BASEDIR}/lib/libomnitrace-dl.so"
# HSA_TOOLS_REPORT_LOAD_FAILURE=1
# ROCP_TOOL_LIB="${BASEDIR}/lib/libomnitrace.so"

# export HSA_TOOLS_LIB
# export HSA_TOOLS_REPORT_LOAD_FAILURE
# export ROCP_TOOL_LIB
